@layer sanitize, base, page, component, utility;

@import url("../modules/sanitize.css/sanitize.css") layer(sanitize);
@import url("../modules/sanitize.css/system-ui.css") layer(sanitize);
@import url("../modules/sanitize.css/forms.css") layer(sanitize);
@import url("../modules/sanitize.css/assets.css") layer(sanitize);

:root {
  /* theme */
  --base-primary: #3b7bf3;
  --base-secondary: #040404;
  --base-tertiary: #fff;
  --base-success: #e5b386;
  --base-warn: #73d373;
  --base-danger: #5f5d5b;

  /* base */
  --base-container-max-size: 540px;
}

@layer utility {
  .sr-only {
    position: absolute;
    inset-block-start: auto;
    inset-inline-start: -10000px;

    overflow: hidden;

    inline-size: 1px;
    block-size: 1px;
  }

  .skip-to-link-container {
    position: relative;
    display: block flow-root;
  }

  .skip-to-main-link {
    position: absolute;
    z-index: 100000;
    inset-inline-start: 50%;
    translate: -50% -100%;

    block-size: 30px;
    padding: 8px;

    color: var(--base-secondary);

    background-color: var(--base-tertiary);

    &:focus {
      translate: -50% 0;
      transition: translate 0.3s;
    }
  }
}

@layer base {
  @font-face {
    font-family: ChiayiCity;

    src: url("../fonts/ChiayiCity.ttf");
  }

  @font-face {
    font-family: "Noto Sans CJK";

    src: local("Noto Sans CJK");
  }

  html {
    font-family: system-ui;

    &:is([lang="nan-Latn-pehoeji"], [lang="en"]) {
      :is(h1, h2, h3, h4, h5, .base-label:not(.checkbox-label, .radio-label), legend, .base-nav-link, .base-button, .tag-delete-dialog-text, .category-delete-dialog-text, caption, dt, .expense-total-text, .expense-delete-dialog-text, .filter-datetime-button, .confirm-restore-dialog-text, .app-installer-description, .expense-copy-dialog-text) {
        font-family: ChiayiCity, system-ui;
        font-weight: bold;
      }
    }

    &:is([lang="zh-Hant-TW"]) {
      :is(h1, h2, h3, h4, h5, .base-label:not(.checkbox-label, .radio-label), legend, .base-nav-link, .base-button, .tag-delete-dialog-text, .category-delete-dialog-text, caption, dt, .expense-total-text, .expense-delete-dialog-text, .filter-datetime-button, .confirm-restore-dialog-text, .app-installer-description, .expense-copy-dialog-text) {
        font-family: "Noto Sans CJK", system-ui;
        font-weight: bold;
      }
    }
  }

  :is(.down-load-resource-list-item, .database-ready-list-item) {
    span {
      display: inline flex;
      gap: 5px;
    }
  }

  @keyframes loader-spin {
    from {
      rotate: 0;
    }

    to {
      rotate: 360deg;
    }
  }

  .loader-icon {
    animation-name: loader-spin;
    animation-duration: 1.5s;
    animation-timing-function: linear;
    animation-iteration-count: infinite;
  }

  .app-installer-dialog {
    inline-size: calc(100% - 10px);

    .check-icon {
      display: none;
    }

    &[data-database-migration-finished] {
      .database-ready-list-item {
        .loader-icon {
          display: none;
        }

        .check {
          display: inline flow;
        }
      }
    }

    &[data-html-worker-ready] {
      & .down-load-resource-list-item {
        .html-loader {
          display: none;
        }

        .check-icon {
          display: inline flow;
        }
      }
    }

    &[data-pglite-worker-ready] {
      & .down-load-resource-list-item {
        .pglite-loader {
          display: none;
        }

        .pglite-check {
          display: inline flow;
        }
      }
    }
  }

  .notification-container {
    pointer-events: none;

    position: fixed;
    z-index: 100000;
    inset-block-start: 0;
    inset-inline: 0;
  }

  @keyframes slide-in-out {
    0% {
      translate: 0 calc(-100% - var(--translate));
    }

    25% {
      translate: 0 calc(0% + var(--translate));
    }

    75% {
      translate: 0 calc(0% + var(--translate));
    }

    100% {
      translate: 0 calc(-100% - var(--translate));
    }
  }

  .notification-success {
    --translate: 40px;

    pointer-events: none;

    display: block flow;

    inline-size: calc(100% - 20px);
    max-inline-size: var(--base-container-max-size);
    margin-inline: auto;
    padding: 10px;
    border: 2px solid var(--base-secondary);
    border-radius: 10px;

    color: var(--base-secondary);

    background-color: color-mix(in srgb, var(--base-success) 95%, transparent);

    animation-name: slide-in-out;
    animation-duration: 3s;
    animation-fill-mode: forwards;

    @media screen and (width <= 540px) {
      --translate: 62px;
    }
  }

  .base-nav {
    position: sticky;
    z-index: 1010;
    inset-block-start: 0;

    max-inline-size: var(--base-container-max-size);
    margin-inline: auto;

    @media screen and (width <= 540px) {
      pointer-events: none;

      position: fixed;
      inset-block-start: initial;
      inset-block-end: 20px;
      inset-inline: 0;

      display: block flex;
      justify-content: center;

      .base-nav-list {
        pointer-events: auto;
      }
    }
  }

  .base-nav-list {
    display: block flex;
    gap: 5px;
    align-items: center;

    margin: 0;
    padding: 0;
    padding-block: 10px;
    padding-inline: 20px;

    background-color: color-mix(in srgb, var(--base-tertiary) 95%, transparent);

    view-transition-name: nav-list;

    @media screen and (width <= 540px) {
      padding: 5px;
      border: 2px solid var(--base-secondary);
      border-radius: 10px;
    }
  }

  .base-nav-list-item {
    display: block flex;
    align-items: center;

    &:last-child {
      margin-inline-start: auto;

      @media screen and (width <= 540px) {
        margin-inline-start: 0;
      }
    }
  }

  .expense-nav-link {
    view-transition-name: expense-nav-link;

    .link-icon {
      view-transition-name: expense-nav-link-icon;
    }

    .link-text {
      view-transition-name: expense-nav-link-text;
    }
  }

  .category-nav-link {
    view-transition-name: category-nav-link;

    .link-icon {
      view-transition-name: category-nav-link-icon;
    }

    .link-text {
      view-transition-name: category-nav-link-text;
    }
  }

  .settings-nav-link {
    view-transition-name: settings-nav-link;

    .link-icon {
      view-transition-name: settings-nav-link-icon;
    }

    .link-text {
      view-transition-name: settings-nav-link-text;
    }
  }

  .base-nav-link {
    position: relative;

    display: block flex;
    gap: 3px;
    align-items: center;

    padding: 5px;
    padding-inline-end: 7px;

    font-weight: bold;
    color: var(--base-secondary);
    white-space: nowrap;

    &::before {
      content: "";
      position: absolute;
      inset: 0;
    }

    &[aria-current] {
      color: var(--base-tertiary);

      &::before {
        z-index: -10;
        border-radius: 10px;
        background-color: var(--base-primary);
        view-transition-name: nav-link-active;
      }
    }
  }

  #main {
    scroll-margin-block-start: 60px;
  }

  .base-container {
    max-inline-size: var(--base-container-max-size);
    margin-inline: auto;
    padding-inline: 20px;
  }

  .base-container-end {
    margin-block-end: 40px;

    @media screen and (width <= 540px) {
      margin-block-end: 90px;
    }
  }

  .base-button {
    display: inline flex;
    align-items: center;

    padding: 8px 10px;
    border: 2px solid transparent;
    border-radius: 10px;

    text-decoration: none;
    white-space: nowrap;

    outline-offset: 5px;

    &.icon-button {
      padding: 5px;
    }

    &.button-primary {
      border-color: var(--base-primary);
      border-width: 2px;
      color: var(--base-tertiary);
      background-color: var(--base-primary);
    }

    &.button-secondary {
      border-color: var(--base-secondary);
      color: var(--base-secondary);
      background-color: var(--base-tertiary);
      outline-color: var(--base-danger);
    }

    &.button-danger {
      border-color: var(--base-danger);
      color: var(--base-tertiary);
      background-color: var(--base-danger);
      outline-color: var(--base-primary);
    }
  }

  .base-form {
    display: block flex;
    flex-direction: column;
    gap: 5px;
    align-items: start;

    button[type="submit"] {
      margin-block-start: 15px;
    }
  }

  .base-input {
    padding: 10px;
    border: 2px solid var(--base-secondary);
    border-radius: 10px;
  }

  .base-label {
    display: block flex;
    align-items: center;
    padding-block: 10px;
    white-space: nowrap;
  }

  .form-invalid-message {
    padding: 5px;
    border: 1px solid var(--base-danger);
    color: var(--base-danger);
    background-color: color-mix(in srgb, var(--base-danger) 5%, transparent);
  }

  .base-dialog {
    position: fixed;
    inset-block-start: 50%;
    inset-inline-start: 50%;
    translate: -50% -50%;

    max-inline-size: var(--base-container-max-size);
    margin: 0;
    padding: 20px;
    border: 2px solid var(--base-secondary);
    border-radius: 10px;

    opacity: 0;

    transition-duration: 0.25s;
    transition-property: opacity, display;
    transition-behavior: allow-discrete;

    &::backdrop {
      opacity: 0;
      transition: opacity 0.25s;
    }

    &[open] {
      opacity: 1;

      @starting-style {
        opacity: 0;
      }

      &::backdrop {
        opacity: 1;

        @starting-style {
          opacity: 0;
        }
      }
    }
  }

  a:has(.base-category-item, .base-tag-item) {
    text-decoration: none;
  }

  .base-category-item {
    display: inline flex;
    align-items: center;

    padding: 5px;
    border: 2px solid var(--base-success);
    border-radius: 10px;

    color: var(--base-secondary);
    text-decoration: none;
    white-space: nowrap;

    background-color: var(--base-success);
  }

  .base-tag-item {
    display: inline flex;
    flex-wrap: wrap;
    gap: 5px;
    align-items: center;

    padding: 5px;
    border: 2px solid var(--base-warn);
    border-radius: 10px;

    color: var(--base-secondary);
    text-decoration: none;
    white-space: wrap;

    background-color: var(--base-warn);

    :is(.tag-group, .tag-name) {
      display: block flex;
      align-items: center;
    }

    .tag-name {
      padding: 0 5px;
      border-radius: 5px;
      color: var(--base-secondary);
      background-color: var(--base-tertiary);
    }
  }

  .base-fieldset {
    display: block flex;
    flex-wrap: wrap;
    gap: 10px;

    border: 2px solid var(--base-secondary);
    border-radius: 10px;
  }

  .base-legend {
    padding-block-start: 10px;
  }

  .input-label-option-group {
    display: inline flex;
    flex-wrap: nowrap;
    gap: 5px;
    align-items: center;

    .base-label {
      padding-block: 5px;
    }
  }
}
